library circle;

{$R circle.RES}
{$D Opaque Software  - Circle1 Demo}


uses wintypes, winprocs, tpw2vb;


{//---------------------------------------------------------------------------
// Resource ID's
//---------------------------------------------------------------------------
// Toolbox bitmap resource IDs.
//---------------------------------------------------------------------------}
const
	IDBMP_Circle	=	8000;
	IDBMP_CircleDOWN	=	8001;
	IDBMP_CircleMONO	 =	8003;
	IDBMP_CircleEGA	  =	8006;


{//---------------------------------------------------------------------------
// Global Variables and Constants
//---------------------------------------------------------------------------}

{//---------------------------------------------------------------------------
// CIRCLE control data and structs
//---------------------------------------------------------------------------}

{//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------}
const
	IPROP_Circle_CTLNAME		=	 0;
	IPROP_Circle_INDEX		=	 1;
	IPROP_Circle_BACKCOLOR	=	 2;
	IPROP_Circle_LEFT		=	 3;
	IPROP_Circle_TOP			=	 4;
	IPROP_Circle_WIDTH		=	 5;
	IPROP_Circle_HEIGHT		=	 6;
	IPROP_Circle_VISIBLE		=	 7;
	IPROP_Circle_PARENT		=	 8;
	IPROP_Circle_DRAGMODE	=	 9;
	IPROP_Circle_DRAGICON	=	 10;
	IPROP_Circle_TAG			=	 11;

const
	PropListCircle : array[0..12]of PPROPINFO =
(
	PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_INDEX,
	PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
	PPROPINFO_STD_VISIBLE,
	PPROPINFO_STD_PARENT,
	PPROPINFO_STD_DRAGMODE,
    PPROPINFO_STD_DRAGICON,
	PPROPINFO_STD_TAG,
	0
);

{//---------------------------------------------------------------------------
// Event procedure parameter prototypes
//---------------------------------------------------------------------------}


{//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------}
const
	EVENT_Circle_CLICK	=	0;
	EVENT_Circle_DRAGDROP =  1;
	EVENT_Circle_DRAGOVER =  2;

EventListCircle: array[0..3]of PEVENTINFO = (
	PEVENTINFO_STD_CLICK,
	PEVENTINFO_STD_DRAGDROP,
	PEVENTINFO_STD_DRAGOVER,
	0
);

{//---------------------------------------------------------------------------
// 	Control Procedure
//	This routine is called for all VB and Windows Msgs.
//---------------------------------------------------------------------------}
function CircleCtlProc(Control: HCtl; Wnd: HWnd;
			Msg, WParam: Word; LParam: LongInt):LongInt; export;
begin
	CircleCtlProc := VBDefControlProc(Control, Wnd, Msg, WParam, LParam);
end;

{//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------}
const
modelCircle: TMODEL = (
	usVersion:		VB_VERSION;				{VB version used by control}
	fl:				0; 						{ Bitfield structure}
	ctlproc:		TFarProc(@CircleCtlProc);	{the control proc.}
	fsClassStyle:	cs_VRedraw or cs_HRedraw;	{ window class style}
	flWndStyle:		ws_Border; 				  	{default window style}
	cbCtlExtra:		0;						{ # bytes alloc'd for HCTL structure}
	idBmpPalette:	IDBMP_Circle;			{ BITMAP id for tool palette}
	DefCtlName: 	NPnt(PChar('Circle')); 	{ default control name prefix.
											  Typecasts PChar to a NPnt.	}
	ClassName:		NPnt(PChar('Circle1'));		{ Visual Basic class name}
	ParentClassName:	0;						{ Parent window class if subclassed}
	proplist:		ofs(PropListCircle)	;		{ Property list}
	eventlist:		ofs(EventListCircle); 		{ Event list}
	nDefProp: 		0;		{ index of default property}
	nDefEvent:		0		{ index of default event}
);

{//---------------------------------------------------------------------------
// Register custom control.
//	This routine is called by VB when the custom control DLL is
//	loaded for use.
//---------------------------------------------------------------------------}
function VBINITCC(usVersion: Word; fRunTime: Boolean): Boolean; export;
begin
	VBINITCC := VBRegisterModel(HInstance, modelCircle);
end;

exports
	VBINITCC index 2,
	CircleCtlProc index 3;

begin

end.
